
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int put_newline;

/* печать аргументов */
void do_echo(int argc, char *argv[])
{
	int i;
	for (i = 0; i < argc; i++) {
		if (i == (argc - 1))
			printf("%s", argv[i]);
		else
			printf("%s ", argv[i]);
	}
}



/* печать аргументов с учетом спец команд \\n \\t и т.д. */
void do_echo_with_escapes(int argc, char *argv[])
{
	int i;
	int end_echo;
	char *c;

	end_echo = 0;

	for (i = 0; i < argc; i++) {
		c = argv[i];

		while (*c) {
			if (*c == '\\') {
				if (end_echo)
					break;
				c++;

				switch (*c) {
				case '\\':
					printf("\\");
					break;

				case 'a':
					printf("\a");
					break;

				case 'b':
					printf("\b");
					break;

				case 'c':
					end_echo = 1;
					put_newline = 0;
					break;

				case 'f':
					printf("\f");
					break;

				case 'n':
					printf("\n");
					break;

				case 'r':
					printf("\r");
					break;

				case 't':
					printf("\t");
					break;

				case 'v':
					printf("\v");
					break;	

				case '\0':
					printf("\\");
					c--;
					break;	

				default:
					printf("\\%c",*c);
					break;
				};
			} else {
				if (end_echo)
					break;
				printf("%c",*c);
			}
			c++;
		}

		if (i != argc-1)
			printf(" ");
	}
}

int
main(int argc, char *argv[])
{

	int opt;
	int enabled_escapes;

	enabled_escapes = 0;
	put_newline = 1;
	opterr = 0;

	while ((opt = getopt(argc, argv, "neE")) != -1) {
		switch (opt) {
		case 'e':
			enabled_escapes = 1;
			break;

		case 'E':
			enabled_escapes = 0;
			break;

		case 'n':
			put_newline = 0;
			break;

		default:
			fprintf(stderr, "Usage: %s [-n] [-E] [-e] string\n", argv[0]);
			exit(EXIT_FAILURE);
			break;
		}
	}

	argc -= optind;
	argv += optind;

	/* выполняется если ,была указана опция -е */
	if (enabled_escapes)
		do_echo_with_escapes(argc, argv);
	else
		do_echo(argc, argv);

	if (put_newline) 
		printf("\n");

	exit(EXIT_SUCCESS);
}







